%global githash 7d2a4e9
%global gitdate 20190828

Name:           qnnpack
Version:        0
Release:        %{gitdate}.git%{githash}%{?dist}
Summary:        Quantized Neural Networks PACKage
License:        BSD
URL:            https://github.com/pytorch/qnnpack

Source0:        %{name}.tar.xz

BuildRequires:  cmake gcc-c++
BuildRequires:  fp16-devel psimd-devel fxdiv-devel cpuinfo-devel pthreadpool-devel

%global __cmake_in_source_build 1

%description
A mobile-optimized library for low-precision high-performance
neural network inference. QNNPACK provides implementation of
common neural network operators on quantized 8-bit tensors.

%package        devel
Summary:        Development files
Requires:       %{name} = %{version}-%{release}

%description    devel
This package contains the development files.



%prep
%setup -q -n %{name}


%build

# externals
sed -i '/PRIVATE fp16/d' CMakeLists.txt
sed -i '/PRIVATE psimd/d' CMakeLists.txt
sed -i '/PRIVATE fxdiv/d' CMakeLists.txt
sed -i '/NOT TARGET/,/ENDIF/d' CMakeLists.txt
sed -i -e 's|PROPERTIES PUBLIC_HEADER include/qnnpack.h|PROPERTIES PUBLIC_HEADER include/qnnpack.h SOVERSION 1 VERSION 1.0|g' CMakeLists.txt


mkdir build
pushd build

%cmake .. -Wno-dev \
       -DCMAKE_SKIP_RPATH=ON \
       -DCMAKE_VERBOSE_MAKEFILE=OFF \
       -DCMAKE_BUILD_TYPE=RelWithDebInfo \
       -DQNNPACK_BUILD_TESTS=OFF \
       -DQNNPACK_BUILD_BENCHMARKS=OFF \
       -DFP16_SOURCE_DIR="%{_includedir}" \
       -DPSIMD_SOURCE_DIR="%{_includedir}" \
       -DFXDIV_SOURCE_DIR="%{_includedir}" \
       -DCPUINFO_SOURCE_DIR="%{_includedir}" \
       -DPTHREADPOOL_SOURCE_DIR="%{_includedir}"


make %{?_smp_mflags}

popd


%install

rm -rf %{buildroot}

pushd build
make install DESTDIR=%{buildroot}
popd

mkdir -p %{buildroot}%{_libdir}
mv -f %{buildroot}/usr/lib/* %{buildroot}%{_libdir}/


rm -rf %{buildroot}/%{_includedir}/gmock
rm -rf %{buildroot}/%{_includedir}/gtest
rm -rf %{buildroot}/%{_libdir}/*.a


%files
%license LICENSE
%doc README.md
%{_libdir}/lib*.so.*

%files devel
%license LICENSE
%doc README.md
%{_includedir}/*
%{_libdir}/lib*.so


%changelog
* Tue Jul 11 2017 Cristian Balint <cristian.balint@gmail.com> - 0.1
- initial build
